;**************************************************************************
;*
;* FILE  intro.asm
;* Copyright (c) 2006, 2007 Daniel Kahlin <daniel@kahlin.net>
;* Written by Daniel Kahlin <daniel@kahlin.net>
;* $Id: intro.asm,v 1.27 2007-09-10 20:51:45 tlr Exp $
;*
;* DESCRIPTION
;*
;******

DEBUG_TIMING	equ	0

;**************************************************************************
;*
;* NAME  show_intro
;*
;* DESCRIPTION
;*
;*
;******
show_intro:
	sei
	lda	#1
	sta	$d03f
; disable badlines, extended colors
	lda	#%00100100
	sta	$d03c
; burst enable, skip internal cycle
	sac	$99
	lda	#%00000011
	sac	$00

	jsr	start_sound
	jsr	init_chars
	jsr	init_sprites
	jsr	wait_wb
	lda	#200
	jsr	waitrast
	jsr	init_screen
si_lp1:	
	lda	$d011
	bmi	si_lp1
	lda	#8
	sta	$d016

	if	DEBUG_TIMING
	inc	$d020
	endif
	jsr	doscroll

	ldx	#0
si_lp2:
	txa
	pha
	lda	basecols,x
	jsr	setbase
	pla
	tax
	inx
	cpx	#9
	bne	si_lp2

	ldx	#0
si_lp3:
	txa
	pha
	jsr	setoutercol
	pla
	tax
	inx
	cpx	#9
	bne	si_lp3

	dec	outeroffs
	bpl	si_skp1
	lda	#outeroffs_len-1
	sta	outeroffs
si_skp1:
	
	if	DEBUG_TIMING
	dec	$d020
	dec	$d020
	inc	$d020
	endif
	
; shift the top of the logo right 4 pixels
	lda	#50+8*3
	jsr	waitrast
	lda	#4+8
	sta	$d016

; shift the bottom logo normal
	lda	#50+8*11
	jsr	waitrast
	lda	#8
	sta	$d016

; scroll
	lda	#50+8*21
	jsr	waitrast
	lda	scrx
	ora	#8
	sta	$d016

; bottom of the screen, normal
	lda	#51+8*22
	jsr	waitrast
	lda	#8
	sta	$d016

	lda	#$7f
	sta	$dc00
	lda	$dc01
	cmp	#$ef
	bne	si_lp1

	jsr	uninit_screen
	jsr	uninit_chars
	jsr	kill_sound

; disable burst, do not skip internal cycles anymore.
	sac	$99
	lda	#%00000000
	sac	$00
; enable badlines again
	lda	#%00000000
	sta	$d03c

	lda	#0
	sta	$d03f
	cli
	rts	

waitrast:
wr_lp1:
	cmp	$d012
	bne	wr_lp1
	if	DEBUG_TIMING
	inc	$d021
	dec	$d021
	endif
	rts

init_chars:
	ldx	#23
ich_lp1:
	lda	extrachars,x
	sta	$3800+8*27,x
	dex
	bpl	ich_lp1
	rts

uninit_chars:
	ldy	$01
	ldx	#23
	lda	#$03
	sta	$01
uch_lp1:
	lda	$d000+8*27,x
	sta	$3800+8*27,x
	dex
	bpl	uch_lp1
	sty	$01
	rts
	
init_sprites:
	lda	#0
	ldx	#$3f
isp_lp1:
	sta	$3780,x
	sta	$37c0,x
	dex
	bpl	isp_lp1

	lda	#%11111111
	ldx	#0
isp_lp2:
	sta	$3780,x
	inx	
	inx	
	inx	
	cpx	#8*3
	bne	isp_lp2
	
	lda	#1
	sta	$d027
		
	lda	#24
	sta	$d000
	sta	$d002
	lda	#50+8*21
	sta	$d001
	sta	$d003
	lda	#0
	sta	$d010
	sta	$d017		; Y-Exp
	sta	$d01b		; Sprite Pri
	sta	$d01d		; X-Exp
	lda	#%00000010
	sta	$d01c		; Sprite MC
	lda	#%00000011
	sta	$d015
	lda	#$df
	sta	$07f8
	lda	#$de
	sta	$07f9
	lda	#0
	sta	$d026
	rts
	

init_screen:
	ldx	#0
is_lp1:
	lda	#0
	sta	$d800+40*4,x
	sta	$d800+40*4+40*6,x
	sta	$d800+40*4+40*12,x
	lda	intro_screen,x
	sta	$0400+40*4,x
	lda	intro_screen+40*6,x
	sta	$0400+40*4+40*6,x
	lda	intro_screen+40*8,x
	sta	$0400+40*4+40*8,x
	inx
	cpx	#40*6
	bne	is_lp1

	ldx	#39
	lda	#1
is_lp2:
	sta	$d800+40*21,x
	dex
	bpl	is_lp2
	rts

uninit_screen:
; kill sprites
	lda	#0
	sta	$d015

	ldx	#0
uis_lp1:
	lda	#$20
	sta	$0400+40*3,x
	sta	$0400+40*3+40*6,x
	sta	$0400+40*3+40*12,x
	inx
	cpx	#40*6
	bne	uis_lp1
	rts


basecols:
	dc.b	14,14,14,14,14
	dc.b	14,14,14,14

outeroffs:
	dc.b	0
outercols:
	dc.b	$06,$00,$00,$00,$00,$00,$00,$00
	dc.b	$06,$00,$00,$00,$00,$00,$00,$00
	dc.b	$06,$00,$00,$00,$00,$00,$00,$00
	dc.b	$06,$00,$00,$00,$00,$00,$00,$00
	dc.b	$06,$00,$00,$00,$00,$00,$00,$00
	dc.b	$06,$00,$00,$00,$00,$00,$00,$00

	if	0
	dc.b	$84,$84,$85,$84,$85,$85,$86,$85
	dc.b	$86,$86,$87,$86,$87,$87,$86,$87
	dc.b	$86,$86,$85,$86,$85,$85,$84,$85
	dc.b	$84,$84,$85,$84,$85,$85,$86,$85
	dc.b	$86,$86,$87,$86,$87,$87,$86,$87
	dc.b	$86,$86,$85,$86,$85,$85,$84,$85
	endif

outeroffs_len	equ	24

setbase:
	pha
	txa
	asl
	tax
	lda	bases,x
	sta	$fb
	lda	bases+1,x
	sta	$fc
	pla

	ldx	#inner_len-1
sbs_lp1:
	ldy	inner,x
	sta	($fb),y
	dex
	bpl	sbs_lp1
	rts

setoutercol:
	pha
	txa
	asl
	tax
	lda	bases,x
	sta	$fb
	lda	bases+1,x
	sta	$fc

	lda	outeroffs
	clc
	adc	#<outercols
	sta	soc_sm1+1
	lda	#0
	adc	#>outercols
	sta	soc_sm1+2
	pla

	ldx	#outer_len-1
soc_lp1:
soc_sm1:
	lda	outercols,x
	ldy	outer,x
	sta	($fb),y
	dex
	bpl	soc_lp1
	rts
	
	
bases:
	dc.w	$d800+40*4+2
	dc.w	$d800+40*4+9
	dc.w	$d800+40*4+16
	dc.w	$d800+40*4+23
	dc.w	$d800+40*4+30
	dc.w	$d800+40*11+6
	dc.w	$d800+40*11+13
	dc.w	$d800+40*11+20
	dc.w	$d800+40*11+27

inner:
	dc.b	40*1+1,40*1+2,40*1+3,40*1+4,40*1+5
	dc.b	40*2+1,40*2+2,40*2+3,40*2+4,40*2+5
	dc.b	40*3+1,40*3+2,40*3+3,40*3+4,40*3+5
	dc.b	40*4+1,40*4+2,40*4+3,40*4+4,40*4+5
	dc.b	40*5+1,40*5+2,40*5+3,40*5+4,40*5+5
inner_len	equ	.-inner
outer:
	dc.b	40*0+0,40*0+1,40*0+2,40*0+3,40*0+4,40*0+5
	dc.b	40*0+6,40*1+6,40*2+6,40*3+6,40*4+6,40*5+6
	dc.b	40*6+6,40*6+5,40*6+4,40*6+3,40*6+2,40*6+1
	dc.b	40*6+0,40*5+0,40*4+0,40*3+0,40*2+0,40*1+0
outer_len	equ	.-outer

;**************************************************************************
;*
;* NAME  doscroll
;*
;******
doscroll:
	dec	scrx
	bpl	dscr_ex1

	lda	#7
	sta	scrx

; set sprite to the contents of the left-most character
	lda	$d800+40*21
	sta	$d027
	lda	$0400+40*21
	sta	$fb
	lda	#0
	asl	$fb
	rol
	asl	$fb
	rol
	asl	$fb
	rol
	clc
	adc	#>$3800
	sta	$fc
	ldy	#0
	ldx	#0
dscr_lp2:
	lda	($fb),y
	sta	$37c0,x
	inx
	inx
	inx
	iny
	cpy	#8
	bne	dscr_lp2
	
		
	ldx	#0
dscr_lp1:
	lda	$0400+40*21+1,x
	sta	$0400+40*21+0,x
	lda	$d800+40*21+1,x
	sta	$d800+40*21+0,x
	inx
	cpx	#39
	bne	dscr_lp1

dscr_sm1:
	lda	scrolltext
	bne	dscr_skp1
	lda	#<scrolltext
	sta	dscr_sm1+1
	lda	#>scrolltext
	sta	dscr_sm1+2
	bra	dscr_sm1
dscr_skp1:
	inc	dscr_sm1+1
	bne	dscr_skp2
	inc	dscr_sm1+2
dscr_skp2:
	and	#$3f
	sta	$0400+40*21+39
dscr_ex1:
	lda	scrx
	clc
	adc	#24-8
	sta	$d000
	sta	$d002
	
	rts

scrx:
	dc.b	7
	
;**************************************************************************
;*
;* NAME  start_sound, fade_sound, kill_sound
;*
;******
start_sound:
	ldx	#$18
ints_lp1:
	lda	soundtab,x
	sta	$d400,x
	dex
	bpl	ints_lp1
	rts
	if	0
fade_sound:
	lda	#5
	sta	soundtab+$18
	sta	$d418
	rts
	endif
kill_sound:
	lda	#$00
	sta	$d404
	sta	$d40b
	sta	$d412
	sta	$d418
	rts
soundtab:
	dc.b	$00,$04,$00,$00,$21,$af,$fa
	dc.b	$01,$04,$00,$00,$15,$a2,$aa
	dc.b	$ff,$01,$00,$00,$21,$af,$fa
	dc.b	$00,$00,$00,$08

;**************************************************************************
;*
;* NAME  charset
;*
;******
extrachars:
; AA "["
	dc.b	%00111100
	dc.b	%01100110
	dc.b	%00111100
	dc.b	%01100110
	dc.b	%01111110
	dc.b	%01100110
	dc.b	%01100110
	dc.b	%00000000
; AE "\"
	dc.b	%01100110
	dc.b	%00111100
	dc.b	%01100110
	dc.b	%01111110
	dc.b	%01100110
	dc.b	%01100110
	dc.b	%01100110
	dc.b	%00000000
; OE "]"
	dc.b	%01100110
	dc.b	%00111100
	dc.b	%01100110
	dc.b	%01100110
	dc.b	%01100110
	dc.b	%01100110
	dc.b	%00111100
	dc.b	%00000000

scrolltext:
	dc.b	"     "
	dc.b	"WELCOME TO THE DTV/HUMMER FLASH TOOL!  "
	dc.b	"DESIGNED AND PROGRAMMED BY DANIEL KAHLIN.     "
	dc.b	"THIS IS VERSION V1.0 FINAL WITH WORKING SUPPORT"
	dc.b	" FOR THE SST FLASH FOUND IN LATER BATCHES OF PAL DTV'S."
	dc.b	"      SPECIAL THANKS TO: "
	dc.b	"SCOUT (FOR PROVIDING ME WITH MY C64 DTV'S), "
	dc.b	"MICHAEL B]HMER (LOTS OF MEASUREMENTS ON THE VIDEO ISSUES), "
	dc.b	"DENNIS SCHMIDT (LOTS OF BETA TESTING), "
	dc.b	"SUSCHMAN (SUGGESTIONS AND BETA TESTING), "
	dc.b	"ALEX JASPERS (FOR HARD TO FIND ATMEL DATASHEETS), "
	dc.b	"DAVID MURRAY (BETA TESTING ON THE HUMMER), "
	dc.b	"TIXIV (MEASUREMENTS ON IDLE CYCLES AND HARDWARE FIX FOR SST FLASHES), "
	dc.b	"NOJOOPA, "
	dc.b	"M.KIESEL, "
	dc.b	"LALLAFA, "
	dc.b	"BLACKY STARDUST, "
	dc.b	"SPIFF, "
	dc.b	"STREET TUFF, "
	dc.b	"PEISELULLI, "
	dc.b	"ZEE, "
	dc.b	"ROLAND T]GEL, "
	dc.b	"NICOLAS WELTE, "
	dc.b	"DOUG GARMON, "
	dc.b	"ROBIN HARBRON"
	dc.b	" AND IREJ ELLSWORTH (WATCH OUT FOR LATCH UPS!)."
	dc.b	"            ADDITIONAL GREETINGS TO: "
	dc.b	"ZYRON, "
	dc.b	"TRAZAN, "
	dc.b	"ZAPAC, "
	dc.b	"MAGERVALP, "
	dc.b	"MERMAID, "
	dc.b	"IOPOP, "
	dc.b	"MADMODDER, "
	dc.b	"GRAHAM, "
	dc.b	"MARKO M\KEL\, "
	dc.b	"PASI OJALA, "
	dc.b	"AND ALL PEOPLE ON THE DTVHACKING FORUM, "
	dc.b	"CSDB, DENIAL, AND FORUM-64.DE...                    "
	dc.b	"              "
	dc.b	0

intro_screen:
	incbin	"data/logo.bin"
; eof
